      subroutine evolvePDF(x,Q,f)
      implicit none
      character*16 s1,dummy
      real*8 f(-6:6)
      real*8 x,Q,xx,qq,up,dn,ubar,dbar,gluon,sbar,cbar,bbar,tbar,Blam
      real*8 xmin,qmax,anx,anq,Q2fit,qini,Ahdn,ordi,anf,mass,pi,alfas
      real*8 Q0,alfas0
      real*8 pardis,alpi,parmflavor,astolam
      integer nflavor,Eorder,j,nx,nq
      data pi / 3.141592653589793d0 /
      external parmflavor
      save nflavor,xmin,qmax,anx,anq
*
	xx = x
	qq = Q
	up   = xx*pardis(1,xx,qq)
	dn   = xx*pardis(2,xx,qq) 
	ubar = xx*pardis(-1,xx,qq)
	dbar = xx*pardis(-2,xx,qq)
	gluon= xx*pardis( 0,xx,qq)

	if(nflavor .ge. 3) then
	   sbar = xx*pardis(-3,xx,qq)
	else
	   sbar = 0.d0
	endif

	if(nflavor .ge. 4) then
	   cbar = xx*pardis(-4,xx,qq)
	else
	   cbar = 0.d0
	endif

	if(nflavor .ge. 5) then
	   bbar = xx*pardis(-5,xx,qq)
	else
	   bbar = 0.d0
	endif

	if(nflavor .eq. 6) then
	   tbar = xx*pardis(-6,xx,qq)
	else
	   tbar = 0.d0
	endif

	f(6) = tbar 
	f(5) = bbar 
	f(4) = cbar 
	f(3) = sbar 
	f(2) = up 
	f(1) = dn 
	f(0) = gluon 
	f(-1) = dbar 
	f(-2) = ubar 
	f(-3) = sbar 
	f(-4) = cbar 
	f(-5) = bbar 
	f(-6) = tbar 
*
	return
*
      entry readevolve
      call bldat1
      call bldat2
      call bldat3

      read(1,*) s1
      if (index(s1,'EVLCTEQ').ne.1) then
         write(*,*) s1,' evolution code requested.'
         write(*,*) 'LHAPDF is compiled with EVLCTEQ evolution code.'
         write(*,*) 'Using EVLCTEQ evolution with default grid.'
         xmin=1d-6
         qmax=1d5
         nx=95
         nq=19
         read(1,*) dummy
      else
         read(1,*) xmin,qmax,nx,nq
      endif
      anx=nx
      anq=nq-1
      return
*
      entry alfasevolve(alfas,Q)
      alfas = pi*alpi(Q)
      return
*
      entry initevolution(Eorder,Q2fit)
*
      Ahdn=1d0
      call ParPdf(1,'IHDN',Ahdn,j)
      call ParPdf(1, 'QMAX',qmax,j)
      call ParPdf(1, 'XMIN',xmin,j)
      call GetOrderAs(j)
      ordi=j+1.0
      call ParQcd(1,'ORDR',ordi,j)
      call GetThreshold(4,mass)
      call ParQcd(1,'M4',mass,j)
      call GetThreshold(5,mass)
      call ParQcd(1,'M5',mass,j)
      mass=180d0
      call ParQcd(1,'M6',mass,j)
      call GetNf(j)
      nflavor=j
      Anf=nflavor
      call ParQcd(1,'NFL',Anf,j)
      qini=sqrt(Q2fit)
      call ParPdf(1,'QINI',qini,j)
      call Evlpar(1,'NFMX', Anf, j)
      ordi=Eorder+1.0
      call ParPdf(1,'IKNL',ordi,j)
      return
*
      entry initevolvePDF
      call GetOrderAs(j)
      call GetAlfas(alfas0,Q0)
      Blam=astolam(alfas0,Q0,j+1,nflavor)
      call SetLam (nflavor,Blam,j+1)
      call ParPdf(1,'NX',anx,j)
      call ParPdf(1,'NT',anq,j)
      call Evolve (parmflavor,j)
      if (j .ne. 0) then
         write(*,*) 'EVLCTEQ Evolve Error code :',j
         stop
      endif
      return
*
      end
*
      double precision function parmflavor(i,x)
      implicit none
      real*8 x,f(-6:6)
      integer i,i0
*
      call parmPDF(x,f)
      i0=i
      if (i.eq.-2) i0=-1
      if (i.eq.-1) i0=-2
      if (i.eq.1) i0=2
      if (i.eq.2) i0=1
      parmflavor=f(i0)/x
      return
*
      end
      
      function astolam(as,q,nloop,nf) 
      implicit double precision (a-h,o-z)
      data pi / 3.141592653589793d0 /
      xlp = nloop-1d0
      b  = (33.0-2.0*nf)/pi/12.0 
      bp = (153.0 - 19.0*nf) / pi / 2.0 / (33.0 - 2.0*nf) * xlp 
      t  = 1.0/b/as 
c----------------------------------------------------------- 
c Solve the equation 
c 
    1 xlt = log(t) 
      ot = t 
c----------------------------------------------------------- 
c Solve the equation 
c Value and Derivative of alfa with respect to t 
c 
      as0  = 1/b/t - bp*xlt/(b*t)**2 
      as1  = - 1/b/t**2 -bp/b**2*(1-2*xlt)/t**3 
      t  = (as-as0)/as1 + t 
      if(abs(ot-t)/ot.gt..00001)goto 1 
      astolam = q/exp(t/2.0) 
      return 
      end 


